/*================================================================ 
 	Copyright 2008, Yoav Goldberg.
 	
 	This file is part of splitSVM.
 
    splitSVM is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    splitSVM is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with splitSVM.  If not, see http://www.gnu.org/licenses/.
     
 ================================================================*/
package yg.classifier.splitsvm;

import gnu.trove.TIntHashSet;

public class FeatsToVecs {
	
	int[][] featsToVecs = null;
	int[] empty = new int[] {};
	
	public FeatsToVecs(TIntHashSet[] featToVecs) {		
		this.featsToVecs = new int[featToVecs.length][];
		for (int i=0;i<featToVecs.length;i++) {
			if (featToVecs[i] != null) {
				this.featsToVecs[i] = featToVecs[i].toArray();
			} else {				
				this.featsToVecs[i] = empty;
			}
		}
	}
	
	public int[] vecsForFeat(int fid) {
		try {
			return this.featsToVecs[fid];
		} catch (RuntimeException e) {
			//System.out.println("empty rare-feature:" + fid);
			return empty; 
		}
	}
	
}
