/*================================================================ 
 	Copyright 2008, Yoav Goldberg.
 	
 	This file is part of splitSVM.
 
    splitSVM is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    splitSVM is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with splitSVM.  If not, see http://www.gnu.org/licenses/.
     
 ================================================================*/
package yg.classifier.splitsvm;

public class LabelsData {

	protected String[] labels = null;	// all the possible labels
	protected String[] trueLabels = null; // cid -> trueLabel
	protected String[] falseLabels = null; // cid -> falseLabel
	
	public LabelsData(String[] labels) {
		this.labels = labels;
	}

	public LabelsData(String[] labels, String[] trueLabels, String[] falseLabels) {
		this.labels = labels;
		this.trueLabels = trueLabels;
		this.falseLabels = falseLabels;		
	}

	public String getFalse(int cid) {
		return falseLabels[cid];
	}
	
	public String getTrue(int cid) {
		return trueLabels[cid];
	}
	
	public int idxForLabel(String s) {
		for (int i = 0; i<labels.length; i++) {
			if (s.equals(labels[i])) {
				return i;
			}			
		}
		return -1;
	}
	
	public String[] getLabels() { return labels; }
	

}
