package yg.classifier.splitsvm.io;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.util.zip.ZipEntry;
import java.util.zip.ZipFile;

public class FastMulticlassZippedModelReader extends FastMulticlassModelReader {

	private ZipFile zipfile;

	public FastMulticlassZippedModelReader(String file_prefix) throws IOException {
		this.zipfile = new ZipFile(file_prefix);
	}
	
	@Override
	protected InputStream getInputStream(String prefix, String extension) throws IOException {
		//System.out.println("Reading splt" + extension );
		ZipEntry ent = this.zipfile.getEntry("splt" + extension);
		if (ent == null) {
			throw new FileNotFoundException("splt" + extension);
		}
		return this.zipfile.getInputStream(ent);
	}


	
}
