/*================================================================ 
 	Copyright 2008, Yoav Goldberg.
 	
 	This file is part of splitSVM.
 
    splitSVM is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    splitSVM is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with splitSVM.  If not, see http://www.gnu.org/licenses/.
     
 ================================================================*/
package yg.classifier.splitsvm.io;

import java.io.BufferedReader;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

public class FeatureMapReader {

	private Map<String, Integer> featToNum;
	private Map<Integer, String> numToFeat;

	public Map<String, Integer> getFeatToNum() {
		return this.featToNum;
	}

	public Map<Integer, String> getNumToFeat() {
		return this.numToFeat;
	}

	public void read(BufferedReader br) throws IOException {
		String line = br.readLine();
		while (line != null && line.trim().length() > 0) {
			String[] parts = line.trim().split("\\s+");
			int num = Integer.parseInt(parts[0]);
			this.featToNum.put(parts[1].intern(),num);
			this.numToFeat.put(num,parts[1].intern());
			line = br.readLine();
		}
	}
		
	public FeatureMapReader() {
		featToNum = new HashMap<String, Integer>();
		numToFeat = new HashMap<Integer, String>();
	}

}
