/*================================================================ 
 	Copyright 2008, Yoav Goldberg.
 	
 	This file is part of splitSVM.
 
    splitSVM is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    splitSVM is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with splitSVM.  If not, see http://www.gnu.org/licenses/.
     
 ================================================================*/
package yg.classifier.splitsvm.wrappers;

import java.io.IOException;

import yg.classifier.splitsvm.FastMulticlassModel;
//import yg.classifier.splitsvm.ProbbedMulticlassModel;

import libsvm.svm_model;
import libsvm.svm_node;
import libsvm.svm_parameter;


public class FastLibSVM {
	
	//private static int[] labelsAsInts = null;
	
	public static FastMulticlassModel svm_load_model(String filenamePrefix) {
		try {
			FastMulticlassModel m = new FastMulticlassModel();
			
			//FastMulticlassModel m = new ProbbedMulticlassModel(filenamePrefix + ".probe.no_lex","LEX_ALL",true);
			//FastMulticlassModel m = new ProbbedMulticlassModel(filenamePrefix + ".probe.no_hs0","LEX_HS0",true);
			//FastMulticlassModel m = new ProbbedMulticlassModel(filenamePrefix + ".probe.no_s0","LEX_S0",true);			
			//FastMulticlassModel m = new ProbbedMulticlassModel(filenamePrefix + ".probe.no_i0","LEX_I0",true);
			//FastMulticlassModel m = new ProbbedMulticlassModel(filenamePrefix + ".probe.no_i1","LEX_I1",true);
			//FastMulticlassModel m = new ProbbedMulticlassModel(filenamePrefix + ".probe.only_hs0","LEX_NO_HS0",true);
			//FastMulticlassModel m = new ProbbedMulticlassModel(filenamePrefix + ".probe.only_s0","LEX_NO_S0",true);			
			//FastMulticlassModel m = new ProbbedMulticlassModel(filenamePrefix + ".probe.only_i0","LEX_NO_I0",true);
			//FastMulticlassModel m = new ProbbedMulticlassModel(filenamePrefix + ".probe.only_i1","LEX_NO_I1",true);
			
			//FastMulticlassModel m = new ProbbedMulticlassModel(filenamePrefix + ".probe.only_i0s0","LEX_NO_I0S0",true);
			//FastMulticlassModel m = new ProbbedMulticlassModel(filenamePrefix + ".probe.only_i1s0","LEX_NO_I1S0",true);
			//FastMulticlassModel m = new ProbbedMulticlassModel(filenamePrefix + ".probe.only_i0i1","LEX_NO_I0I1",true);
			//FastMulticlassModel m = new ProbbedMulticlassModel(filenamePrefix + ".probe.only_hs0s0","LEX_NO_HS0S0",true);
			//FastMulticlassModel m = new ProbbedMulticlassModel(filenamePrefix + ".probe.only_i0hs0","LEX_NO_I0HS0",true);
			//FastMulticlassModel m = new ProbbedMulticlassModel(filenamePrefix + ".probe.only_i1hs0","LEX_NO_I1HS0",true);
		
			m.read(filenamePrefix, false);			
			//return MulticlassModelReader.readMulticlassModel(filenamePrefix);			
			return m; 
		} catch (IOException e) {
			System.out.println("Can't load " + filenamePrefix);
			e.printStackTrace();
			return null;
		}
	}

	// TODO: TEST!!!
	public static double svm_predict(FastMulticlassModel model, svm_node[] svm_nodes) {
		return Integer.parseInt(model.classifyToLabels(svm_nodes));
	}

	public static int svm_get_nr_class(FastMulticlassModel fastModel) {
		return fastModel.getNumOfLabels();
	}


	public static void svm_get_labels(FastMulticlassModel fastModel, int[] labels) {				
		System.arraycopy(fastModel.getLabelsAsInts(),0,labels,0,labels.length);
	}

	public static void svm_predict_values(FastMulticlassModel fastModel, svm_node[] x, double[] dec_values) {
		fastModel.getClassifiersScores(x, dec_values);
	}
	
	/*
	public static double svm_get_svr_probability(svm_model model)  {
		 // TODO: add support for this?
	     System.err.print("Model doesn't contain information for SVR probability inference\n");
		 return 0;
	}
	
	public static double svm_predict_probability(svm_model model, svm_node[] x, double[] prob_estimates) {
		// TODO
		throw new RuntimeException("Unimplemnted Method");
	}
	*/
	

	
}
