#================================================================ 
#   Copyright 2008, Yoav Goldberg.
#   
#   This file is part of splitSVM.
# 
#    splitSVM is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    splitSVM is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public License
#   along with splitSVM.  If not, see http://www.gnu.org/licenses/.
#    
#================================================================
from interfaces import FeatureVectorInterface, ClassifierDataInterace #, ClassifiersCollectionInterface

class SVMLightFeatureVector(FeatureVectorInterface):
   def __init__(self, ai, feats, id=None):
      FeatureVectorInterface.__init__(self, ai, feats, id)

class SVMLightClassifierData(ClassifierDataInterace):
   def __init__(self, vecs, thrs = 0, true_label = '1', false_label='-1'):

      feature_ids = set()
      for v in vecs: 
         for f in v.features(): feature_ids.add(f)
      feature_ids = list(sorted(feature_ids))

      ClassifierDataInterace.__init__(self,vecs, thrs, feature_ids, true_label, false_label)

   def __str__(self):
      return "\n".join(self._head + [str(v) for v in self._vecs])
      
